#include <propeller.h>
#include "tv_text_rs.h"
#include "TV_Array.h"
                                                                               


//Global variables
		 long stack[30];   //For input stream cog
         char buf[buflen]; //Text Buffer max length
		 int cx;           //char from input stream
		 int pb,po;        //Text Buffer pointer, TV offset pointer
		 char cc;          //character hidden by cursor
         int id = 0;       //tv cog #
	     int z,j;          //Keyboard Buffer input pointer, output pointer 
   		 char cmdbuf[20];  //Holds command string
		 char kb[64];      //Keyboard Buffer        
		   
static int rx_period;	 
		    
/**
 * This is the main global tv text control/status structure.
 */
tvText_t gTvText;

/**
 * This is the TV text screen area.
 */
static short gscreen[TV_TEXT_SCREENSIZE];

/**
 * This is the TV color palette area.
 */
static int gcolors[TV_TEXT_COLORTABLE_SIZE];


 int tvText_start(int basepin);      

/*
 * This is the TV palette.
 */
static char gpalette[TV_TEXT_COLORTABLE_SIZE] =     
{                   // fgRGB  bgRGB
    0x07, 0x0a,     // 0    white / dark blue
    0x07, 0xbb,     // 1   yellow / brown
    0x9e, 0x9b,     // 2  magenta / black
    0x04, 0x07,     // 3     grey / white
    0x3d, 0x3b,     // 4     cyan / dark cyan
    0x6b, 0x6e,     // 5    green / gray-green
    0xbb, 0xce,     // 6      red / pink
    0x3c, 0x0a      // 7     cyan / blue
};

/*
 * This should set the character foreground and screen background.
 * API are available to get/set this.
 */
static int color = 0;

/*
 * global var to keep cogid so we don't have to pass parm to stop
 */
static int gTvTextCog = 0;

/*
 * TV_Text start function starts TV on a cog
 * See header file for more details.
 */
 
int tvText_start(int basepin)
	{
	int i;
//    col   = 0; // init vars
 //   row   = 0;
    gTvText.status = 0;
    gTvText.enable = 1;
    gTvText.pins   = ((basepin & 0x38) << 1) | (((basepin & 4) == 4) ? 0b101 : 0); // | ((basepin & 4 == 4) ? 0 : -1) & 0b101; //((basepin & 4 == 4) & 0b0101);
    gTvText.mode   = 0b10010;
    gTvText.screen = (long) gscreen;
    gTvText.colors = (long) gcolors;
    gTvText.ht = TV_TEXT_COLS;
    gTvText.vt = TV_TEXT_ROWS;
    gTvText.hx = 4;
    gTvText.vx = 1;
    gTvText.ho = 0;
    gTvText.vo = 0;
    gTvText.broadcast = 0;
    gTvText.auralcog  = 0;
    id = cognewNative(TV_Text_Array, &gTvText);
    gTvTextCog = id+1;
    tvText_setColorPalette(&gpalette[TV_TEXT_PAL_WHITE_BLUE]);
    wordfill(&gscreen[0], 0x220, TV_TEXT_SCREENSIZE);
	for(i=0; i<=buflen; i++) { buf[i]=0x20;}
    wait(1000);
    return id;
}

/**
 * stop stops the cog running the native assembly driver 
 */

void tvText_stop(void)
{
    int id = gTvTextCog - 1;
    if(gTvTextCog > 0) {
        asm("cogstop %id");
    }
}
/*
 * TV_Text setcolors function sets the palette to that defined by pointer.
 * See header file for more details.
 */
void    tvText_setColorPalette(char* ptr)
{
    int  ii = 0;
    int  mm = 0;
    int  fg = 0;
    int  bg = 0;
    for(ii = 0; ii < TV_TEXT_COLORTABLE_SIZE; ii += 2)
    {
        mm = ii + 1; 
        fg = ptr[ii] << 0;
        bg = ptr[mm] << 0;
        gcolors[ii]  = fg << 24 | bg << 16 | fg << 8 | bg;
        gcolors[mm]  = fg << 24 | fg << 16 | bg << 8 | bg;
   }        
}

/*
 * TV_Text dec function prints a decimal number at current position
 * See header file for more details.
 */
void  tvText_dec(int value)
{
    char b[128];
    itoa(b, value, 10);
    tvText_str(b);
}


void tvText_str(char* sptr)
{   
    int l,k;
    l=(TV_TEXT_SCREENSIZE-39);
    while(*sptr) {
        k =(*(sptr++));
		gscreen[l++]=((2<< 1 | k & 1) << 10) + (0x200 + (k & 0xfe));
    }
}


void cmd()                         
 {
	 int m = 0 ;
	 int i = 0;
	 int l = TV_TEXT_SCREENSIZE-30;
	 short int ix; 
     for(ix=(TV_TEXT_SCREENSIZE-39) ; ix<=(TV_TEXT_SCREENSIZE-2) ;  ix++)
	 { 
	 gscreen[ix]=((2 << 1 | SPACE & 1) << 10) + (0x200 + (SPACE & 0xfe));
	 }
	 tvText_str("CMD>");
	 while(cx != RETN)
	 {
	 msleep(80);
	 getcx();
	 if (i<=20)
	 {
	 if (cx!=0x0)
	 	{
	     gscreen[l++]=((2<< 1 | cx & 1) << 10) + (0x200 + (cx & 0xfe));
	     cmdbuf[i++] = cx;
		 }
		 }
	 }
    //execute cmd string here or return to editor	 
 }

 void retx()                             
{	 									  //Too much code to do a simple job.......uhmmmm
 	 int v,k,j,i,temp;					 
	 v =1+(pb/TV_TEXT_COLS);             //calculate number of lines in buffer include part line 
	 v = v*40;
     k = (pb % TV_TEXT_COLS);            //calculate number on characters in current line
	 buf[pb]=cc; 
	 /***
	 **move all chars below this line down 1 line to make room for newline
	 */ 
	 for (i=1; i<=TV_TEXT_COLS; i++)
	    {
	     for (j=buflen; j>=v; j--){buf[j]= buf[j-1]; }    
		}
	/***
	*clear the line after move
	*/  
	for (i=0; i<=TV_TEXT_COLS-1; i++){buf[(v)+i]= SPACE;}            
    /***
	*move chars from cursor to EOL to line below
	*/
	for (i= 0;i <= TV_TEXT_COLS-(k+1) ;i++)  {buf[(v)+i]= buf[pb+i];} 
	
	/***
	*now from clear from cursor clear to EOL  
	*/
    for (i = 0;i <= TV_TEXT_COLS-(k+1) ;i++) {buf[(pb)+i]= SPACE;} 
	/***
	*now reset curcor position 
	*/
	pb=v;                                
	buf[pb] ='_';
	}


	 
// keep text buffer in snyc with gscreen 
void screen_update()
	 { 
	 int i,temp;
	 if ((pb-po)>=lastrow){	 po += 40;}          //update offset 
	 temp = po;		                             // offset pointer to temp
	 for (i=0; i<=lastrow  ; i++ )	 
	    { 
		gscreen[i]=((color << 1 | buf[temp] & 1) << 10) + (0x200 + (buf[temp] & 0xfe));
		 temp++;
		 }
}

void    tvText_out(int c)              //This is self explanitory
{		 
        switch(c)
        {
            case cls:
                wordfill(&gscreen[0], color << 11 |0x220, TV_TEXT_SCREENSIZE);
                po= 0;
                pb = 0;
                break;
            case home:
                po = 0;
                pb = 0;
                break;
            case esc:  
			   
            case tab: 
				 	 cmd();	
				     break;   // fall though ATM
            case 0x0A:   // fall though ATM
            case BS:   // fall though ATM
	          if (pb >= 0)
			  {
			  buf[pb] = 0x20;
			  pb--;
			  cc = buf[pb];
			  buf[pb] = '_';
			  }
			  break;	
            case 0x0c:   // fall though ATM 
            case RETN:  
	             retx();	
				 break;	
			case up:
			if (pb >= TV_TEXT_COLS)
			{
			if ((pb - po) <= TV_TEXT_COLS)
			   {
			   po -= TV_TEXT_COLS;
			   }
			   else
			{ 
			    buf[pb]=cc;
			    pb -= TV_TEXT_COLS;
			    cc = buf[pb];
			    buf[pb]='_';
			}
			}	
			break; 	 
			case down:
			if (pb <= buflen)
			{
			if (pb - po > TV_TEXT_SCREENSIZE)
			     {
			     po += TV_TEXT_COLS;
		    	}
			    else
			    {
			buf[pb] = cc;
			pb += TV_TEXT_COLS;
			cc = buf[pb];
			buf[pb] = '_';
			}
			}
			break;
			case right:
			if (pb <= buflen)
			{
			buf[pb] = cc;
			  pb++;
			  cc = buf[pb];
			  buf[pb] = '_';
			} 
			break;  
			case left:
			if (pb >= 0)
			  {
			  buf[pb] = cc;
			  pb--;
			  cc = buf[pb];
			  buf[pb] = '_';
			  }
			break;  
			default:	
			buf[pb] = c;   	   				 //save new character in buffer
			pb++;           		         //inc pointer
			cc = buf[pb];  			  		 //save current cursor position
			buf[pb] ='_';      		   		 //write new cursor

			}     
         screen_update();                    //update screen ..keep in sync

}

static struct baudmap {                                      //leave in for now
    int baud;
    int rx;
    int tx;
} baudmap[] = {
    MAP(9600), MAP(19200), MAP(38400), MAP(57600),0
	};
 
void kyb_init(int baud)
{
    struct baudmap *p;
    int bits = ASIO_TX_PIN_MAP;                                //just to set the rx low and tx high safety
    DIRA = bits;
    for (p = baudmap; p->baud && p->baud != baud; p++)
        ; 
    if (p)
        {
        rx_period = ASIO_BASE_PERIOD * p->rx;
        }
}


static int getbit (int pin)
{
    int rc = 0;
    int bits;
    int per = rx_period;
    asm("mov USER0, CNT\n"
    "add USER0, %per\n"
    "waitcnt USER0,#0");
	bits = INA;
    rc = (bits & pin) ? ~ASIO_RX_INVERTED : ASIO_RX_INVERTED;
    rc &= 1;
    return rc;
}

void keyin()
{   
    int ii;
    int bits;
    int rx; 
    int byte;
    int cnt;
    int per = rx_period + 100;   //changed, 400 hudred was far too high.
	while(1)
	{
	byte = 0x00;
    do {
        bits = INA;
        rx = (bits & ASIO_RX_PIN_MAP) ? 0 : 1;
    } while(rx == ASIO_RX_INVERTED);
    
    // wait for start bit to pass    
    cnt = CNT + per;
    WAITCNTN(cnt, 0);
    // get bits on baud rate schedule
    for(ii = 0; ii < 8; ii++) {
        rx = getbit(ASIO_RX_PIN_MAP);
        byte = byte | (rx << 8);
        byte = byte >> 1;
    }
    getbit(ASIO_RX_PIN_MAP); // get stop bit
	if (byte!=0x00)
	{
      z++;	
	  if (z>=60){z=0;}
	  kb[z]=byte;  
	}
}
}


void getcx()
{
if(j!=z)                                       //is buffer empty ??   'z' is input pointer in Keyin
	 {
	 j++;
 	 if (j>=60){j=0;}                          //rewind buffer 'j' output pointer
			cx =kb[j];
			  if (cx==0x1b)                     //look for arrow key sequence
			      {
				  j++;
				  if (j>=60){j=0;}   
				  msleep(80);                  //don't check too early 
		       	  if (kb[j]== 0x5b )           //check next key in sequence
	              		{
						j++;
						if (j>=60){j=0;}   
				        cx= 0x80 + kb[j];      //found it now modify for tvText_out
						return;                //return with arrow code 
				        }
					cx=0x0;	                   //not decoded 
					return;
				  } 		
			return;                           //normal return	    
     }
	cx=0x0;	                                  //buffer empty
	return; 	 
}

void main()
	 {
	 po = 0;
	 pb = 0;
	 j=0;
     z=0;
	  kyb_init(57600);
	  tvText_start(12);
	  cognew(keyin,&stack[18]);
   	 while(1)
	 {		 
	 getcx();
	 if (cx!=0x0)
	     {
		 tvText_out(cx);
         }
     }
}